<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRoomStayCandidateType ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfRoomStayCandidateType extends AbstractStructArrayBase
{
    /**
     * The RoomStayCandidate
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgRoomStayCandidateType[]
     */
    public $RoomStayCandidate;
    /**
     * Constructor method for ArrayOfRoomStayCandidateType
     * @uses DgArrayOfRoomStayCandidateType::setRoomStayCandidate()
     * @param \dgsoft\StructType\DgRoomStayCandidateType[] $roomStayCandidate
     */
    public function __construct(array $roomStayCandidate = array())
    {
        $this
            ->setRoomStayCandidate($roomStayCandidate);
    }
    /**
     * Get RoomStayCandidate value
     * @return \dgsoft\StructType\DgRoomStayCandidateType[]|null
     */
    public function getRoomStayCandidate()
    {
        return $this->RoomStayCandidate;
    }
    /**
     * Set RoomStayCandidate value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgRoomStayCandidateType[] $roomStayCandidate
     * @return \dgsoft\ArrayType\DgArrayOfRoomStayCandidateType
     */
    public function setRoomStayCandidate(array $roomStayCandidate = array())
    {
        foreach ($roomStayCandidate as $arrayOfRoomStayCandidateTypeRoomStayCandidateItem) {
            // validation for constraint: itemType
            if (!$arrayOfRoomStayCandidateTypeRoomStayCandidateItem instanceof \dgsoft\StructType\DgRoomStayCandidateType) {
                throw new \InvalidArgumentException(sprintf('The RoomStayCandidate property can only contain items of \dgsoft\StructType\DgRoomStayCandidateType, "%s" given', is_object($arrayOfRoomStayCandidateTypeRoomStayCandidateItem) ? get_class($arrayOfRoomStayCandidateTypeRoomStayCandidateItem) : gettype($arrayOfRoomStayCandidateTypeRoomStayCandidateItem)), __LINE__);
            }
        }
        $this->RoomStayCandidate = $roomStayCandidate;
        return $this;
    }
    /**
     * Add item to RoomStayCandidate value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgRoomStayCandidateType $item
     * @return \dgsoft\ArrayType\DgArrayOfRoomStayCandidateType
     */
    public function addToRoomStayCandidate(\dgsoft\StructType\DgRoomStayCandidateType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgRoomStayCandidateType) {
            throw new \InvalidArgumentException(sprintf('The RoomStayCandidate property can only contain items of \dgsoft\StructType\DgRoomStayCandidateType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RoomStayCandidate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgRoomStayCandidateType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgRoomStayCandidateType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgRoomStayCandidateType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgRoomStayCandidateType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgRoomStayCandidateType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RoomStayCandidate
     */
    public function getAttributeName()
    {
        return 'RoomStayCandidate';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfRoomStayCandidateType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
